<html lang="en">
<head>
<title>Overview - Semantic Manual</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Semantic Manual">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="index.html#Top" title="Top">
<link rel="next" href="Installation_002fBasic-Configuration.html#Installation_002fBasic-Configuration" title="Installation/Basic Configuration">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<!--
This manual documents Semantic, a new intrastructure for parser
based text analysis for Emacs.

Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2007 Eric M. Ludlam
Copyright (C) 2001, 2002, 2003, 2005 David Ponce
Copyright (C) 2002, 2003 Richard Y. Kim

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.1 or any later version published by the Free Software
     Foundation; with the Invariant Sections being list their titles,
     with the Front-Cover Texts being list, and with the Back-Cover
     Texts being list.  A copy of the license is included in the
     section entitled ``GNU Free Documentation License''.
-->
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Overview"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Installation_002fBasic-Configuration.html#Installation_002fBasic-Configuration">Installation/Basic Configuration</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="index.html#Top">Top</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<h2 class="chapter">1 Overview</h2>

<p>This chapter gives the overview of <i>semantic</i> and its goals.

<p>With Emacs, regular expressions (and syntax tables) are the basis of
identifying components in a programming language source for purposes
such as color highlighting.  This approach has proved is usefulness,
but have limitations.

<p><i>semantic</i> provides a new intrastructure that goes far beyond text
analysis based on regular expressions.

<p><i>semantic</i> uses <dfn>parsers</dfn> to analyze programming language
sources.  For languages that can be described using a context-free
grammar, parsers can be based on the grammar of the language.  Or they
can be <dfn>external parsers</dfn> implemented using any means.  This
allows the use of a regular expression parser for non-regular
languages, or external programs for speed.

<p><i>semantic</i> provides extensive tools to help support a new language. 
An original <acronym>LL</acronym> parser, and a Bison-like <acronym>LALR</acronym>
parser are included.  So, for a regular language, all that the
developer needs to do is write a grammar file along with appropriate
semantic rules.

<p><i>semantic</i> allows an uniform representation of language components,
and provides a common <acronym>API</acronym> so that programmers can develop
applications that work for all languages.  The distribution includes
good set of tools and examples for the application writers, that
demonstrate the usefulness of <i>semantic</i>.

<p>The following diagram illustrates the benefits of using <i>semantic</i>:

     <dl>
<dt><strong>Please Note:</strong><dd>The words in all-capital are those that <i>semantic</i> itself provides. 
Others are current or future languages or applications that are not
distributed along with <i>semantic</i>. 
</dl>

<pre class="example">                                                                  Applications
                                                                      and
                                                                   Utilities
                                                                     -------
                                                                    /       \
                    +---------------+    +--------+    +--------+
              C ---&gt;| C      PARSER |---&gt;|        |    |        |
                    +---------------+    |        |    |        |
                    +---------------+    | COMMON |    | COMMON |&lt;--- SPEEDBAR
           Java ---&gt;| JAVA   PARSER |---&gt;|        |    |        |
                    +---------------+    | PARSE  |    | PARSE  |&lt;--- SENATOR
                    +---------------+    |        |    |        |
         Python ---&gt;| PYTHON PARSER |---&gt;| TREE   |    | TREE   |&lt;--- DOCUMENT
                    +---------------+    |        |    |        |
                    +---------------+    | FORMAT |    | API    |&lt;--- SEMANTICDB
         Scheme ---&gt;| SCHEME PARSER |---&gt;|        |    |        |
                    +---------------+    |        |    |        |&lt;--- jdee
                    +---------------+    |        |    |        |
        Texinfo ---&gt;| TEXI.  PARSER |---&gt;|        |    |        |&lt;--- ecb
                    +---------------+    |        |    |        |
     
                         ...                ...           ...         ...
     
                    +---------------+    |        |    |        |&lt;--- app. 1
        Lang. A ---&gt;| A      Parser |---&gt;|        |    |        |
                    +---------------+    |        |    |        |&lt;--- app. 2
                    +---------------+    |        |    |        |
        Lang. B ---&gt;| B      Parser |---&gt;|        |    |        |&lt;--- app. 3
                    +---------------+    |        |    |        |
     
                          ...        ...     ...          ...       ...
     
                    +---------------+    |        |    |        |
        Lang. Y ---&gt;| Y      Parser |---&gt;|        |    |        |&lt;--- app. ?
                    +---------------+    |        |    |        |
                    +---------------+    |        |    |        |&lt;--- app. ?
        Lang. Z ---&gt;| Z      Parser |---&gt;|        |    |        |
                    +---------------+    +--------+    +--------+
</pre>
<ul class="menu">
<li><a accesskey="1" href="Semantic-Components.html#Semantic-Components">Semantic Components</a>
</ul>

</body></html>

